#pragma once
#if defined(DLL_EXPORTS)
#define WING_API __declspec(dllexport)
#else
#define WING_API __declspec(dllimport)
#endif

#include <steam/steam_api.h>
#include <string>
using namespace std;

#include "easylogging.h"

// صint code, string msg, string data
typedef void (*WingCallback)(int, wstring, wstring);

namespace WingProxy {
	WING_API void Init(wstring appId, wstring appKey, WingCallback callback);
	
	WING_API void Login(WingCallback callback);
	WING_API void Logout();
	WING_API void Exit();

	WING_API void QueryProducts(WingCallback callback); // ǲ⣬һCP
	WING_API bool IsPayAvailable();
	WING_API void CallPay(wstring productId, wstring extInfo, WingCallback callback);
	
	WING_API void SetServerId(wstring serverId);
	WING_API void SetGameUserId(wstring gameUserId); //ΪϷɫIDWINGSDKUserID
	WING_API void SetNickName(wstring nickName);
	WING_API void SetLevel(int level);

	WING_API void PostEvent(const wstring& eventName, const wstring& params = L"", double eventValue = numeric_limits<double>::quiet_NaN());
}